{
 "cells": [
  {
   "cell_type": "markdown",
   "id": "cde37a2c",
   "metadata": {},
   "source": [
    "## Polymorphisim"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "id": "cbf01223",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T16:25:03.156587Z",
     "start_time": "2022-10-07T16:25:03.151596Z"
    }
   },
   "outputs": [],
   "source": [
    "class cars:\n",
    "    def category(self):\n",
    "        print(\"There are different category of cars\")\n",
    "        \n",
    "    def seater(self):\n",
    "        print(\"different seats for different category\")\n",
    "\n",
    "class hatchback(cars):\n",
    "    def seater(self):\n",
    "        print(\"This is a 4 seater car\")\n",
    "\n",
    "class sedan(cars):\n",
    "    def seater(self):\n",
    "        print(\"This is a 5 seater car\")\n",
    "\n",
    "class suv(cars):\n",
    "    def seater(self):\n",
    "        print(\"this is a 6 seater car\")\n",
    "        "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "id": "483e099a",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T16:25:04.626359Z",
     "start_time": "2022-10-07T16:25:04.620512Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "this is a 6 seater car\n",
      "This is a 4 seater car\n",
      "This is a 5 seater car\n"
     ]
    }
   ],
   "source": [
    "obj_car = cars()\n",
    "polo= hatchback()\n",
    "honda_city = sedan()\n",
    "tata_safari = suv()\n",
    "\n",
    "tata_safari.seater()\n",
    "polo.seater()\n",
    "honda_city.seater()\n"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "223885ea",
   "metadata": {},
   "source": [
    "## Encapsulation"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "3596da76",
   "metadata": {},
   "source": [
    "**Protected Mode**"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "id": "1efb8151",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T16:25:12.041695Z",
     "start_time": "2022-10-07T16:25:12.033969Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "The value is accessible from parent class 3\n",
      "The value is changed in a protected mode 5\n",
      "5\n"
     ]
    }
   ],
   "source": [
    "class parent:\n",
    "    def __init__(self):\n",
    "        self._a=3\n",
    "\n",
    "class child(parent):\n",
    "    def __init__(self):\n",
    "        parent.__init__(self)\n",
    "        print(\"The value is accessible from parent class\", self._a)\n",
    "        self._a = 5\n",
    "        print(\"The value is changed in a protected mode\", self._a)\n",
    "        \n",
    "obj_child  = child()\n",
    "print(obj_child._a)\n",
    "        \n",
    "        "
   ]
  },
  {
   "cell_type": "markdown",
   "id": "bed3c7c3",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T16:26:02.279733Z",
     "start_time": "2022-10-07T16:26:02.274348Z"
    }
   },
   "source": [
    "**Private Mode**"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "id": "e7f4c9aa",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T16:26:37.534803Z",
     "start_time": "2022-10-07T16:26:36.956025Z"
    }
   },
   "outputs": [
    {
     "ename": "AttributeError",
     "evalue": "'child' object has no attribute '_child__a'",
     "output_type": "error",
     "traceback": [
      "\u001b[0;31m---------------------------------------------------------------------------\u001b[0m",
      "\u001b[0;31mAttributeError\u001b[0m                            Traceback (most recent call last)",
      "Input \u001b[0;32mIn [5]\u001b[0m, in \u001b[0;36m<cell line: 12>\u001b[0;34m()\u001b[0m\n\u001b[1;32m      9\u001b[0m         \u001b[38;5;28mself\u001b[39m\u001b[38;5;241m.\u001b[39m__a \u001b[38;5;241m=\u001b[39m \u001b[38;5;241m5\u001b[39m\n\u001b[1;32m     10\u001b[0m         \u001b[38;5;28mprint\u001b[39m(\u001b[38;5;124m\"\u001b[39m\u001b[38;5;124mThe value is changed in a protected mode\u001b[39m\u001b[38;5;124m\"\u001b[39m, \u001b[38;5;28mself\u001b[39m\u001b[38;5;241m.\u001b[39m__a)\n\u001b[0;32m---> 12\u001b[0m obj_child  \u001b[38;5;241m=\u001b[39m \u001b[43mchild\u001b[49m\u001b[43m(\u001b[49m\u001b[43m)\u001b[49m\n\u001b[1;32m     13\u001b[0m \u001b[38;5;28mprint\u001b[39m(obj_child\u001b[38;5;241m.\u001b[39m_a)\n",
      "Input \u001b[0;32mIn [5]\u001b[0m, in \u001b[0;36mchild.__init__\u001b[0;34m(self)\u001b[0m\n\u001b[1;32m      6\u001b[0m \u001b[38;5;28;01mdef\u001b[39;00m \u001b[38;5;21m__init__\u001b[39m(\u001b[38;5;28mself\u001b[39m):\n\u001b[1;32m      7\u001b[0m     parent\u001b[38;5;241m.\u001b[39m\u001b[38;5;21m__init__\u001b[39m(\u001b[38;5;28mself\u001b[39m)\n\u001b[0;32m----> 8\u001b[0m     \u001b[38;5;28mprint\u001b[39m(\u001b[38;5;124m\"\u001b[39m\u001b[38;5;124mThe value is accessible from parent class\u001b[39m\u001b[38;5;124m\"\u001b[39m, \u001b[38;5;28;43mself\u001b[39;49m\u001b[38;5;241;43m.\u001b[39;49m\u001b[43m__a\u001b[49m)\n\u001b[1;32m      9\u001b[0m     \u001b[38;5;28mself\u001b[39m\u001b[38;5;241m.\u001b[39m__a \u001b[38;5;241m=\u001b[39m \u001b[38;5;241m5\u001b[39m\n\u001b[1;32m     10\u001b[0m     \u001b[38;5;28mprint\u001b[39m(\u001b[38;5;124m\"\u001b[39m\u001b[38;5;124mThe value is changed in a protected mode\u001b[39m\u001b[38;5;124m\"\u001b[39m, \u001b[38;5;28mself\u001b[39m\u001b[38;5;241m.\u001b[39m__a)\n",
      "\u001b[0;31mAttributeError\u001b[0m: 'child' object has no attribute '_child__a'"
     ]
    }
   ],
   "source": [
    "class parent:\n",
    "    def __init__(self):\n",
    "        self.__a=3\n",
    "\n",
    "class child(parent):\n",
    "    def __init__(self):\n",
    "        parent.__init__(self)\n",
    "        print(\"The value is accessible from parent class\", self.__a)\n",
    "        self.__a = 5\n",
    "        print(\"The value is changed in a protected mode\", self.__a)\n",
    "        \n",
    "obj_child  = child()\n",
    "print(obj_child._a)\n",
    "        "
   ]
  },
  {
   "cell_type": "markdown",
   "id": "7b6c588e",
   "metadata": {},
   "source": [
    "## Numpy "
   ]
  },
  {
   "cell_type": "markdown",
   "id": "6cf37dd0",
   "metadata": {},
   "source": [
    "https://numpy.org/doc/stable/user/absolute_beginners.html"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "id": "a729a02b",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T16:28:32.423721Z",
     "start_time": "2022-10-07T16:28:25.707913Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Requirement already satisfied: numpy in /Users/rishavdas/.local/lib/python3.8/site-packages (1.22.3)\r\n"
     ]
    }
   ],
   "source": [
    "!pip install --user numpy "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "id": "44ed4887",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2023-01-04T14:12:47.969409Z",
     "start_time": "2023-01-04T14:12:47.691006Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "[1 2 3 4]\n"
     ]
    }
   ],
   "source": [
    "import numpy as np \n",
    "arr = np.array([1,2,3,4])\n",
    "print(arr)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 9,
   "id": "f5b0af53",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T16:32:39.471284Z",
     "start_time": "2022-10-07T16:32:39.467387Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "1\n"
     ]
    }
   ],
   "source": [
    "print(arr.ndim)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 10,
   "id": "268c367c",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T16:32:49.120803Z",
     "start_time": "2022-10-07T16:32:49.116900Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "(4,)\n"
     ]
    }
   ],
   "source": [
    "print(arr.shape)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 11,
   "id": "a36db824",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T16:33:34.768818Z",
     "start_time": "2022-10-07T16:33:34.764668Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "4\n"
     ]
    }
   ],
   "source": [
    "print(arr.size)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 14,
   "id": "8aa3fef6",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T16:35:48.709697Z",
     "start_time": "2022-10-07T16:35:48.702706Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "2\n",
      "(2, 3)\n",
      "6\n",
      "[[1 2 3]\n",
      " [4 5 6]]\n"
     ]
    }
   ],
   "source": [
    "arr = np.array([[1,2,3], [4,5,6]])\n",
    "print(arr.ndim)\n",
    "print(arr.shape)\n",
    "print(arr.size)\n",
    "print(arr)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "id": "62d76a4f",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2023-01-04T14:13:31.570558Z",
     "start_time": "2023-01-04T14:13:31.565189Z"
    }
   },
   "outputs": [],
   "source": [
    "arr = np.array([[[1,2,3], [4,5,6]], [[2,3,4], [7,8,9]]])"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "id": "d02ecbb3",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2023-01-04T14:13:31.940528Z",
     "start_time": "2023-01-04T14:13:31.936693Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "3\n",
      "(2, 2, 3)\n",
      "12\n",
      "[[[1 2 3]\n",
      "  [4 5 6]]\n",
      "\n",
      " [[2 3 4]\n",
      "  [7 8 9]]]\n"
     ]
    }
   ],
   "source": [
    "print(arr.ndim)\n",
    "print(arr.shape)\n",
    "print(arr.size)\n",
    "print(arr)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "id": "1b0b2212",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2023-01-04T14:18:08.515450Z",
     "start_time": "2023-01-04T14:18:08.499227Z"
    }
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "6"
      ]
     },
     "execution_count": 7,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "arr[0][1][2]"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 9,
   "id": "664d090a",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2023-01-04T14:20:43.692233Z",
     "start_time": "2023-01-04T14:20:43.687797Z"
    }
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "2"
      ]
     },
     "execution_count": 9,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "arr[1][0][0]"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 11,
   "id": "80ff71f5",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2023-01-04T14:23:35.633626Z",
     "start_time": "2023-01-04T14:23:35.625846Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Dimension of the array is 4\n",
      "Shape of the array is (2, 2, 2, 3)\n",
      "size of the array is 24\n",
      "[[[[ 1  2  3]\n",
      "   [ 4  5  6]]\n",
      "\n",
      "  [[ 2  3  4]\n",
      "   [ 7  8 92]]]\n",
      "\n",
      "\n",
      " [[[ 1  2  3]\n",
      "   [ 4  5  6]]\n",
      "\n",
      "  [[ 2  3  4]\n",
      "   [ 7  8  9]]]]\n"
     ]
    }
   ],
   "source": [
    "arr = np.array([[[[1,2,3], [4,5,6]], [[2,3,4], [7,8,92]]], [[[1,2,3], [4,5,6]], [[2,3,4], [7,8,9]]]])\n",
    "print(f\"Dimension of the array is {arr.ndim}\")\n",
    "print(f\"Shape of the array is {arr.shape}\")\n",
    "print(f\"size of the array is {arr.size}\")\n",
    "print(arr)"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "16e09c6b",
   "metadata": {},
   "source": [
    "**Accessing the values**"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 12,
   "id": "63c292b3",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2023-01-04T14:23:38.176692Z",
     "start_time": "2023-01-04T14:23:38.169810Z"
    }
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "92"
      ]
     },
     "execution_count": 12,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "arr[0][1][1][2]"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 20,
   "id": "1b8cf8e4",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T16:58:30.375831Z",
     "start_time": "2022-10-07T16:58:30.369351Z"
    }
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "4"
      ]
     },
     "execution_count": 20,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "arr[1][0][1][0]"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 24,
   "id": "e45bc68c",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:03:56.928073Z",
     "start_time": "2022-10-07T17:03:56.924350Z"
    }
   },
   "outputs": [],
   "source": [
    "arr = np.zeros((3,5))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 25,
   "id": "c7525991",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:03:59.988966Z",
     "start_time": "2022-10-07T17:03:59.982532Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "[[0. 0. 0. 0. 0.]\n",
      " [0. 0. 0. 0. 0.]\n",
      " [0. 0. 0. 0. 0.]]\n"
     ]
    }
   ],
   "source": [
    "print(arr)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 26,
   "id": "d9252350",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:04:29.877746Z",
     "start_time": "2022-10-07T17:04:29.873913Z"
    }
   },
   "outputs": [],
   "source": [
    "arr = np.ones((3,5))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 27,
   "id": "dd05ae4b",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:04:37.368990Z",
     "start_time": "2022-10-07T17:04:37.363004Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "[[1. 1. 1. 1. 1.]\n",
      " [1. 1. 1. 1. 1.]\n",
      " [1. 1. 1. 1. 1.]]\n"
     ]
    }
   ],
   "source": [
    "print(arr)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 28,
   "id": "367633ef",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:05:05.534848Z",
     "start_time": "2022-10-07T17:05:05.528042Z"
    }
   },
   "outputs": [],
   "source": [
    "arr = np.random.random((4,5))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 29,
   "id": "0e55fe78",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:05:09.518934Z",
     "start_time": "2022-10-07T17:05:09.512890Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "[[0.0832065  0.16893906 0.0836634  0.93177855 0.08920558]\n",
      " [0.45437723 0.75164775 0.61608685 0.22854408 0.00422047]\n",
      " [0.87191738 0.81409727 0.2259578  0.42254737 0.26047689]\n",
      " [0.22217664 0.45670074 0.05542232 0.55405838 0.33033938]]\n"
     ]
    }
   ],
   "source": [
    "print(arr)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 38,
   "id": "2588af1f",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:17:50.408429Z",
     "start_time": "2022-10-07T17:17:50.400619Z"
    }
   },
   "outputs": [],
   "source": [
    "arr = np.array([[1,2,3,7], [4,5,6,8], [7,8,9,3]])"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 39,
   "id": "99847672",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:17:52.454516Z",
     "start_time": "2022-10-07T17:17:52.450360Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "[[1 2 3 7]\n",
      " [4 5 6 8]\n",
      " [7 8 9 3]]\n"
     ]
    }
   ],
   "source": [
    "print(arr)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 40,
   "id": "01bb36ad",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:17:56.606144Z",
     "start_time": "2022-10-07T17:17:56.598086Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "2\n"
     ]
    }
   ],
   "source": [
    "print(arr.ndim)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 41,
   "id": "23ffc283",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:18:00.089210Z",
     "start_time": "2022-10-07T17:18:00.085779Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "(3, 4)\n"
     ]
    }
   ],
   "source": [
    "print(arr.shape)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 42,
   "id": "dd6d18e5",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:18:02.997336Z",
     "start_time": "2022-10-07T17:18:02.993746Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "12\n"
     ]
    }
   ],
   "source": [
    "print(arr.size)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 54,
   "id": "3d4ee06d",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:23:09.473203Z",
     "start_time": "2022-10-07T17:23:09.466915Z"
    }
   },
   "outputs": [],
   "source": [
    "new_shape  = arr.reshape(4,3)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 55,
   "id": "641861c4",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:23:12.425521Z",
     "start_time": "2022-10-07T17:23:12.421400Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "[[1 2 3]\n",
      " [7 4 5]\n",
      " [6 8 7]\n",
      " [8 9 3]]\n"
     ]
    }
   ],
   "source": [
    "print(new_shape)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 47,
   "id": "1b01a616",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:18:55.437833Z",
     "start_time": "2022-10-07T17:18:55.434976Z"
    }
   },
   "outputs": [],
   "source": [
    "new_shape  = new_shape.reshape(2,2,3)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 48,
   "id": "2a8f4af7",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:19:04.438627Z",
     "start_time": "2022-10-07T17:19:04.433402Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "[[[1 2 3]\n",
      "  [7 4 5]]\n",
      "\n",
      " [[6 8 7]\n",
      "  [8 9 3]]]\n"
     ]
    }
   ],
   "source": [
    "print(new_shape)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 49,
   "id": "c59cd4c7",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:20:19.114023Z",
     "start_time": "2022-10-07T17:20:19.110732Z"
    }
   },
   "outputs": [],
   "source": [
    "new_shape  = new_shape.reshape(2,2,3,1)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 50,
   "id": "13c81ca5",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:20:24.897816Z",
     "start_time": "2022-10-07T17:20:24.894329Z"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "[[[[1]\n",
      "   [2]\n",
      "   [3]]\n",
      "\n",
      "  [[7]\n",
      "   [4]\n",
      "   [5]]]\n",
      "\n",
      "\n",
      " [[[6]\n",
      "   [8]\n",
      "   [7]]\n",
      "\n",
      "  [[8]\n",
      "   [9]\n",
      "   [3]]]]\n"
     ]
    }
   ],
   "source": [
    "print(new_shape)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 56,
   "id": "cde7df5d",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:24:28.729807Z",
     "start_time": "2022-10-07T17:24:28.725194Z"
    }
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "array([[1, 2, 3, 7],\n",
       "       [4, 5, 6, 8],\n",
       "       [7, 8, 9, 3]])"
      ]
     },
     "execution_count": 56,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "arr"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 57,
   "id": "7ae709de",
   "metadata": {
    "ExecuteTime": {
     "end_time": "2022-10-07T17:25:07.187397Z",
     "start_time": "2022-10-07T17:25:07.178872Z"
    }
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "(array([0, 2]), array([2, 3]))"
      ]
     },
     "execution_count": 57,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "np.where(arr==3)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "id": "affe517e",
   "metadata": {},
   "outputs": [],
   "source": []
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3 (ipykernel)",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.8.8"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 5
}
